--jednodkov komente budou pi zpracovn ignorovny

--SKUPINA 1
/*1;1;25;
Vpis vech zznam tabulky Customer*/
SELECT CustomerId, Title, FirstName, LastName, BirthDay, Email from [Customer];

/*1;2;25;
Vpis seznamu vech zkaznk setdnch podle roku narozen.
*/
SELECT CustomerId, Title, FirstName, LastName, BirthDay, Email FROM [Customer] ORDER BY year(birthday) DESC

/*
1;3;1;
Vype prmrnou cenu vech vrobk.
*/

SELECT avg(price) from product

/*
1;4;12;
Vpis jmen a cen produkt, jejich cena s DPH (pedpokldme, e v DB jsou ceny bez DPH) je vt ne deset tisc. Cena je zaokrouhlena
na cel koruny smrem nahoru. Vpis je setzen podle vypoten ceny od nejvt po nejmen.
*/
SELECT Name, ceiling([Price] * 1.21) from Product where ceiling([Price] * 1.21) > 10000
order by ceiling([Price] * 1.21) desc

--SKUPINA 2
/*
2;1;5;
Vpis produkt, jejich cena je vt ne 5000 K a zrove pat do kategorie 2 nebo 6 (atribut CategoryId)
*/
Select name From Product where Price>5000 and (CategoryId in (2,6)) 

/*
2;2;3;
Vpis PS a mst, jejich PS zanj slem 53 nebo 54.
*/
select distinct zipcode,city from Adress where Zipcode like '53___'  or Zipcode like '54___'

/*2;3;15;Vpis PS a mst, jeji PS nekon sudou slic. */
select distinct zipcode,city from Adress where Zipcode not like '%[0,2,4,6,8]' 

/*2;4;3; Vpis jmen a pjmen vech zkaznk, kte jsou mlad 50 let a jejich kestn jmno je Adam nebo Josef*/
select firstname,lastname,datediff(year,Birthday,getdate()) as vek from Customer
WHERE datediff(year,Birthday,getdate()) < 50 and (firstName='Adam' or firstname = 'Josef')

--SKUPINA 3
--?udlat tak, e bude jedno zadn a 4 rzn zpisy?
/*
3;1;4;
Vpis vech produkt, kter si koupily alespo dva rzn zkaznci
*/
select productId from Product
except (select productId from OrderItem)
/*3;2;4;Vpis vech produkt, kter si koupily alespo dva rzn zkaznci.*/
select productId from Product p1 where not exists (select productId from OrderItem oi where oi.ProductId=p1.ProductId)
/*3;3;4;Vpis vech produkt, kter si koupily alespo dva rzn zkaznci.*/
select productId from Product p1 where ProductId <> all (select productId from OrderItem) 
/*3;4;4;Vpis vech produkt, kter si koupily alespo dva rzn zkaznci.*/
select productId from Product where productId not in (select productId from OrderItem) 

--SKUPINA 4
/*4;1;1; Vrt prmrnou cenu vech produkt*/
select AVG(price) from Product
/*
4;2;8;
Vpis ID zkaznka a poet jeho uskutennch objednvek.
*/
select c.CustomerId,COUNT(*) as PocetObjednavek from [Customer] c join [Order] o on c.CustomerId = o.CustomerId
group by c.CustomerId

/*4;3;10;
Vpis vech objednvek a celkov ceny objednvky. Celkov cena se spot jako souet cen vech poloek objednvky. Piem cena jedn
poloky objednvky se spot jako  poet kus * cena za kus.
*/
select o.OrderId,SUM(oi.Amount * oi.PricePcs) from [Order] o, [OrderItem] oi
where o.OrderId = oi.OrderId
group by o.OrderId

/*4;4;7;
Vpis vech objednvek, kter maj nejmn 3 poloky objednvky.*/
select o.OrderId from [Order] o, [OrderItem] oi
where o.OrderId = oi.OrderId
group by o.OrderId having COUNT(*) >= 3

--SKUPINA 5
/*5;1;8; Vpis vech zkaznk, kte uskutenili alespo jednu objednvku (maj zznam v tabulce [Order]).*/
select distinct c.customerId from [Customer] c JOIN [order] o on o.CustomerId=c.CustomerId

/*5;2;8; Vpis vech zkaznk, kte uskutenili alespo jednu objednvku (maj zznam v tabulce [Order]).*/
select customerId from [Customer] where CustomerId in (select CustomerId from [Order])

/*
5;3;25;
Vpis vech produkt, a sumy prodanch kus. Vpis bude obsahovat i produkty, kter zatm nejsou v dn objednvce.
*/
select  p.productId,p.name,SUM(i.Amount) from product p left join orderitem i on p.productId = i.productId
group by p.productId,p.name

/*5;4;2;
Vpis nzvu kategorie a potu jejich podkategori. Vpis bude obsahovat i  */
select c.Email,count(o.OrderId) as pocetObj from Customer c left join [Order] o 
on c.CustomerId = o.OrderId
where c.Title = 'Bc.'
group by c.Email
order by  pocetObj desc


--SKUPINA 6
/*
6;1;11;
Vpis produkt, kter si koupili alespo dva rzn zkaznci.
U kadho produktu bude navc vypsno jmno a pjmen zkaznka, kter si ho koupil prvn.
*/

select distinct oi1.ProductId,	(Select c3.FirstName + ' '+c3.LastName from [Order] o3 join [Customer] c3 on o3.CustomerId = c3.CustomerId
			 					where [DATE] = (select MIN([date]) from [Order] o,[OrderItem] oi
												where o.OrderId = oi.OrderId and oi.ProductId = oi1.ProductId)) as PrvniZakaznik
from Customer c1, [Order] o1, OrderItem oi1
where c1.CustomerId= o1.CustomerId and o1.OrderId = oi1.OrderId 
and exists (select c2.CustomerId from Customer c2, [Order] o2, OrderItem oi2
			where c2.CustomerId= o2.CustomerId and o2.OrderId = oi2.OrderId 
			and c1.CustomerId <> c2.CustomerId and oi1.ProductId = oi2.ProductId) 
			
/*
6;2;5;
Sestava s msnm pehledem objednvek. Pro kad rok a msc vpis obsahuje poet vytvoench objednvek v tomto
msci, prmrn poet poloek objednvky v tomto msci a nzev nejprodvanjcho produktu v tomto msci.
*/
select YEAR(o.date) as Rok,MONTH(o.date) as Mesic,COUNT(*) as pocetObj,
	(select AVG(cast(oi1.amount as decimal(6,2))) 
	from [OrderItem] oi1 
	where oi1.OrderId in	(select OrderId from [Order] 
							where YEAR(date)=YEAR(o.date)and MONTH(DATE)=MONTH(o.date) )) 
	as PrumernyPocet,
	(select p2.Name  
	from [Product] p2 
	where p2.ProductId in	(select top 1 ProductId from [Order] o3 join [OrderItem] oi3 on o3.OrderId=oi3.OrderId
							where YEAR(date)=YEAR(o.date)and MONTH(DATE)=MONTH(o.date) 
							group by oi3.ProductId having SUM(oi3.Amount)=MAX(oi3.Amount)) )
	as Nejprodavanejsi
from [order] o
group by YEAR(o.date),MONTH(o.date)
